;Colour bars program
;-------------------
;Binary created using DAsm 2.12 running on an Amiga.

   PROCESSOR   6502

BALLPHIY    EQU   #$0000
BALLPLOY    EQU   #$0001
BALLSCRPY   EQU   #$0700
BALLPHIX    EQU   #$0002
BALLPLOX    EQU   #$0003
BALLSCRPX   EQU   #$0703
BALLVLOY    EQU   #$0004
BALLVHIY    EQU   #$0005
BALLVLOX    EQU   #$0006
BALLVHIX    EQU   #$0007
BALLACCY    EQU   #$0008
BALLACCX    EQU   #$0009
BALLVISIBLE EQU   #$000A
FIRED       EQU   #$000B
HIT         EQU   #$000C
MISSED      EQU   #$000D
READY       EQU   #$000E
PLAYER      EQU   #$000F
CONTROLLER1 EQU   #$0010
CONTROLLER2 EQU   #$0011
TERRAINPTR  EQU   #$12        ;Pointer to Terrain
TERRCHRPTR  EQU   #$14        ;Pointer to Terrain CHR.
MAXTERRAIN  EQU   #$0016
TERRAINBASE EQU   #$0017      ;Pointer to start of Terrain.
P1RANDBASE  EQU   #$0018
P2RANDBASE  EQU   #$0019

;-----------------------
P1POSY      EQU   #$0040
P2POSY      EQU   #$0041
P1POSX      EQU   #$0042
P2POSX      EQU   #$0043
P1VINITHIY  EQU   #$0044
P2VINITHIY  EQU   #$0045
P1VINITLOY  EQU   #$0046
P2VINITLOY  EQU   #$0047
P1VINITHIX  EQU   #$0048
P2VINITHIX  EQU   #$0049
P1VINITLOX  EQU   #$004A
P2VINITLOX  EQU   #$004B


P1SCORE     EQU   #$004E
P2SCORE     EQU   #$004F
;-----------------------
VBWAIT      EQU   #$0050

;----------------------

BALLCHR     EQU   #$0701
P1VHIY      EQU   #$0711         ;Sprites for Y,X Initial Velocity
P1VLOY      EQU   #$0715
P1VHIX      EQU   #$0719
P1VLOX      EQU   #$071D
P2VHIY      EQU   #$0721         ;Sprites for Y,X Initial Velocity
P2VLOY      EQU   #$0725
P2VHIX      EQU   #$0729
P2VLOX      EQU   #$072D
P1SCRSCORE  EQU   #$0731         ;Score on-screen
P2SCRSCORE  EQU   #$0735
P1CHRPOSY   EQU   #$0740
P1CHRPOSX   EQU   #$0743
P2CHRPOSY   EQU   #$0748
P2CHRPOSX   EQU   #$074B

   ORG   $C000    ;16Kb PRG-ROM, 8Kb CHR-ROM

Reset_Routine  SUBROUTINE
   cld         ;Clear decimal flag
   sei         ;Disable interrupts
;----------------------------------------------------------
   lda   $2002
   sta   P1RANDBASE        ;Randomize Stuff???
   lda   $4016
   sta   P2RANDBASE
   lda   #$00
   sta   TERRAINBASE

;----------------------------------------------------------

.WaitV   lda $2002
   bpl .WaitV     ;Wait for vertical blanking interval
   ldx #$00
   stx $2000
   stx $2001      ;Screen display off, amongst other things
   dex
   txs         ;Top of stack at $1FF

;Clear (most of) the NES' WRAM. This routine is ripped from "Duck Hunt" - I should probably clear all
;$800 bytes.
   ldy #$07    ;To clear 8 x $100 bytes, from $000 to $7FF?
   sty $01        ;Store count value in $01
   ldy #$00
   sty $00
   lda #$00

.Clear   sta ($00),y    ;Clear $100 bytes
   dey
   bne .Clear

   dec $01        ;Decrement "banks" left counter
   bpl .Clear     ;Do next if >= 0


   lda   #$20
   sta   $2006
   lda   #$00
   sta   $2006

   ldx   #$00
   ldy   #$10
.ClearPPU sta $2007
   dex
   bne   .ClearPPU
   dey
   bne   .ClearPPU

   lda   #$00
   sta   $2003
   tay
.ClearSpr sta   $2004
   dey
   bne   .ClearSpr

;********* Initialize Palette to specified colour ********

   ldx   #$3F
   stx   $2006
   ldx   #$00
   stx   $2006

   ldx   #$0D     ;Colour Value (Black)
   ldy   #$20     ;Clear BG & Sprite palettes.
.InitPal stx $2007
   dey
   bne   .InitPal
;*********************************************************

   lda   #$3F
   sta   $2006
   lda   #$01
   sta   $2006
   lda   #$00
   sta   $2007
   lda   #$10
   sta   $2007
   lda   #$30
   sta   $2007

   lda   #$3F
   sta   $2006
   lda   #$11
   sta   $2006
   lda   #$1B
   sta   $2007
   lda   #$2A
   sta   $2007
   lda   #$3A
   sta   $2007

   lda   #$21
   sta   $2006
   lda   #$10
   sta   $2006
   lda   #$41
   sta   $2007

   lda   #$25
   sta   $2006
   lda   #$10
   sta   $2006
   lda   #$42
   sta   $2007

;-----------------BALL DATA ----------------------------

   lda   #$F0
   sta   MAXTERRAIN        ;1024 Bytes for now

   lda   #$00
   sta   FIRED
   sta   HIT
   sta   MISSED
   sta   PLAYER
   sta   P1SCORE
   sta   P2SCORE

   lda   #$01
   sta   READY

;   lda   #$B0
;   sta   P1POSY
   lda   #$30
   sta   P1POSX

;   lda   #$80
;   sta   P2POSY
   lda   #$D0
   sta   P2POSX


   lda   #$01
   sta   P1VINITHIY
   lda   #$00
   sta   P1VINITLOY

   lda   #$00
   sta   P1VINITHIX
   lda   #$40
   sta   P1VINITLOX

   lda   #$01
   sta   P2VINITHIY
   lda   #$00
   sta   P2VINITLOY

   lda   #$00
   sta   P2VINITHIX
   lda   #$40
   sta   P2VINITLOX


   lda   #$05
   sta   BALLACCY
   lda   #$00
   sta   BALLACCX

   lda   #$01
   sta   BALLVISIBLE
   lda   #$02
   sta   BALLCHR


;------------------------------
   lda   #$20       ;Set up Velocity Sprites
   sta   $0710
   sta   $0714
   lda   #$28
   sta   $0718
   sta   $071C

   lda   #$10
   sta   $0713
   sta   $071B
   lda   #$18
   sta   $0717
   sta   $071F

   lda   #$20       ;Set up Velocity Sprites for P2
   sta   $0720
   sta   $0724
   lda   #$28
   sta   $0728
   sta   $072C

   lda   #$E0
   sta   $0723
   sta   $072B
   lda   #$E8
   sta   $0727
   sta   $072F

   lda   #$07        ;Set up Score Display
   sta   P1SCRSCORE-1
   sta   P2SCRSCORE-1
   lda   #$14
   sta   P1SCRSCORE+2
   lda   #$E0
   sta   P2SCRSCORE+2

;-------------------------------

;Enable vblank interrupts, etc.
   lda   #%10001000
   sta   $2000

;----------------- RANDOMNESS --------------
.TitleScreen
   inc   P1RANDBASE
   dec   P2RANDBASE
   inc   TERRAINBASE              ;Set up random placement
   lda   MAXTERRAIN
   cmp   TERRAINBASE
   bne   .NotOutofTerrain
   lda   #$00
   sta   TERRAINBASE
.NotOutofTerrain
   lda   CONTROLLER1
   and   #%00010000
   beq   .TitleScreen

   jsr   InitTerrain
   jsr   InitTanks
   jsr   InitBall
   jsr   DrawTerrain
;-------------------------------------------

   lda   #%00011110        ;Screen on, sprites on, show leftmost 8 pixels, colour
   sta   $2001
;  cli            ;Enable interrupts(?)

;Now just loop forever?
.Loop

   lda   READY
   bne   .ReadyForControllerRead
   jmp   .NotReady

.ReadyForControllerRead

;---------------------------------------------------------
   lda   PLAYER            ;Set up for Player 1 or 2
   asl
   asl
   asl
   asl
   tax
;----------------------------------------------------------

   lda   CONTROLLER1
   and   #%00001000
   beq   .NotUp
   lda   CONTROLLER1
   and   #%11110111
   sta   CONTROLLER1
   lda   BALLVLOY
   clc
   adc   #$01
   sta   BALLVLOY
   lda   BALLVHIY
   adc   #$00
   sta   BALLVHIY

   lda   BALLVLOY
   sta   P1VLOY,X
   lda   BALLVHIY
   ora   #$10
   sta   P1VHIY,X
   lda   P1VLOY,X
   lsr
   lsr
   lsr
   lsr
   ora   #$10
   sta   P1VLOY,X

.NotUp

   lda   CONTROLLER1
   and   #%00000100
   beq   .NotDown
   lda   CONTROLLER1
   and   #%11111011
   sta   CONTROLLER1
   lda   BALLVLOY
   sec
   sbc   #$01
   sta   BALLVLOY
   lda   BALLVHIY
   sbc   #$00
   sta   BALLVHIY

   lda   BALLVLOY
   sta   P1VLOY,X
   lda   BALLVHIY
   ora   #$10
   sta   P1VHIY,X
   lda   P1VLOY,X
   lsr
   lsr
   lsr
   lsr
   ora   #$10
   sta   P1VLOY,X


.NotDown

   lda   CONTROLLER1
   and   #%00000001
   beq   .NotRight
   lda   CONTROLLER1
   and   #%11111110
   sta   CONTROLLER1
   lda   BALLVLOX
   clc
   adc   #$01
   sta   BALLVLOX
   lda   BALLVHIX
   adc   #$00
   sta   BALLVHIX

   lda   BALLVLOX
   sta   P1VLOX,X
   lda   BALLVHIX
   ora   #$10
   sta   P1VHIX,X
   lda   P1VLOX,X
   lsr
   lsr
   lsr
   lsr
   ora   #$10
   sta   P1VLOX,X

.NotRight

   lda   CONTROLLER1
   and   #%00000010
   beq   .NotLeft
   lda   CONTROLLER1
   and   #%11111101
   sta   CONTROLLER1
   lda   BALLVLOX
   sec
   sbc   #$01
   sta   BALLVLOX
   lda   BALLVHIX
   sbc   #$00
   sta   BALLVHIX

   lda   BALLVLOX
   sta   P1VLOX,X
   lda   BALLVHIX
   ora   #$10
   sta   P1VHIX,X
   lda   P1VLOX,X
   lsr
   lsr
   lsr
   lsr
   ora   #$10
   sta   P1VLOX,X

.NotLeft
   lda   CONTROLLER1
   and   #%10000000          ;A
   beq   .NotA

   ldx   PLAYER
   lda   #$01
   sta   FIRED
   lda   #$00
   sta   MISSED
   lda   #$00
   sta   READY
   lda   #$01
   sta   BALLVISIBLE
   lda   BALLVHIY             ;Copy Initial Velocities
   sta   P1VINITHIY,X
   lda   BALLVLOY
   sta   P1VINITLOY,X
   lda   BALLVHIX
   sta   P1VINITHIX,X
   lda   BALLVLOX
   sta   P1VINITLOX,X

   lda   PLAYER
   beq   .NotA
   lda   BALLVHIX
   eor   #$FF              ;Reverse direction if Player 2
   sta   BALLVHIX
   lda   BALLVLOX
   eor   #$FF
   sta   BALLVLOX


.NotA

.NotReady
   jmp   .Loop

DrawTerrain SUBROUTINE
;--------------------------------------
; INPUTS: A: Name Table Location
;         Y: Pointer Counter
;--------------------------------------
   ldx   #%10001100        ;Inc Address by 32
   stx   $2000
   ldx   #$00
   stx   $0100             ;Temporary
   lda   #$20
   sta   $0101
   ldy   #$00
.DrawTerr1
   lda   $0101
   sta   $2006
   lda   $0100
   sta   $2006
   lda   (TERRAINPTR),Y    ;Must use Y reg to get proper value!!
   tax
   lda   #$00
.DrawTerr2
   sta   $2007
   dex
   bne   .DrawTerr2
   lda   #$1A              ;30 Rows(?) - 3 rows of Menu
   sec
   sbc   (TERRAINPTR),Y
   tax
;   lda   (TERRCHRPTR),Y
   lda   #$80
   sta   $2007
   dex
   lda   #$80
.DrawTerr3
   sta   $2007
   dex
   bne   .DrawTerr3
   inc   $0100
   iny
   lda   #$20
   and   $0100
   beq   .DrawTerr1
   lda   #$00
   sta   $0100
   inc   $0101
   inc   $0101
   inc   $0101
   inc   $0101
   cpy   #$40
   bne   .DrawTerr1
   lda   #%10001000        ;Inc Address by 1
   sta   $2000
   rts

InitTerrain SUBROUTINE
;   lda   #$F0              ;For now, 1024-64 bytes (/4)
;   sta   MAXTERRAIN
   lda   #<.TerrainMap
   sta   TERRAINPTR
   lda   #>.TerrainMap
   sta   TERRAINPTR+1

   lda   #$00
   sta   $0100
   lda   TERRAINBASE
   asl
   rol   $0100
   asl
   rol   $0100
   clc
   adc   TERRAINPTR
   sta   TERRAINPTR
   lda   $0100
   adc   TERRAINPTR+1
   sta   TERRAINPTR+1

   lda   #<.TerrainCharMap
   sta   TERRCHRPTR
   lda   #>.TerrainCharMap
   sta   TERRCHRPTR+1
   rts

.TerrainMap
   INCLUDE Terrain1024.asm

.TerrainCharMap
   INCLUDE TanksTerrainChar.asm


InitTanks SUBROUTINE

.InitP1X
   lda   P1RANDBASE
   and   #%11111000
   sta   P1POSX
   lda   P2RANDBASE
   and   #%11111000
   sta   P2POSX
;----------- Get Y-Position from Terrain ------------
   lda   P1POSX
   lsr
   lsr
   lsr
   tay
   lda   (TERRAINPTR),Y
   tay
   cmp   #$03
   bpl   .X1isFine
   lda   P1POSX
   clc
   adc   #$08
   sta   P1POSX
   jmp   .InitP1X

.X1isFine
   dey
   tya
   asl
   asl
   asl
   sta   P1POSY

.InitP2X
   lda   P2POSX
   lsr
   lsr
   lsr
   clc
   adc   #$20
   tay
   lda   (TERRAINPTR),Y
   tay
   cmp   #$03
   bpl   .X2IsFine
   lda   P2POSX
   clc
   adc   #$08
   sta   P2POSX
   jmp   .InitP2X

.X2IsFine
   dey
   tya
   asl
   asl
   asl
   sta   P2POSY
;----------------------------------------------------

   lda   P1POSY            ;Set up Tank sprites & Position
   sta   P1CHRPOSY
   sta   P1CHRPOSY+4
   lda   P1POSX
   sta   P1CHRPOSX
   lda   #$08
   clc
   adc   P1POSX
   sta   P1CHRPOSX+4
   lda   #$20
   ldx   #$01
   sta   P1CHRPOSY+1
   lda   #$21
   inx
   sta   P1CHRPOSX+2

   lda   P2POSY
   sta   P2CHRPOSY
   sta   P2CHRPOSY+4
   lda   #%01000000
   sta   P2CHRPOSY+2
   sta   P2CHRPOSY+6
   lda   P2POSX
   sta   P2CHRPOSX
   lda   #$08
   clc
   adc   P2POSX
   sta   P2CHRPOSX+4
   lda   #$21
   sta   P2CHRPOSY+1
   lda   #$20
   sta   P2CHRPOSX+2

   rts

ShowHideTanks SUBROUTINE
   lda   BALLPHIX
   and   #$40
   beq   .HideTank2
   lda   #$00
   sta   P1CHRPOSY+1
   sta   P1CHRPOSY+5
   lda   #$21
   sta   P2CHRPOSY+1
   lda   #$20
   sta   P2CHRPOSY+5
   jmp   .SaveTanks
.HideTank2
   lda   #$00
   sta   P2CHRPOSY+1
   sta   P2CHRPOSY+5
   lda   #$20
   sta   P1CHRPOSY+1
   lda   #$21
   sta   P1CHRPOSY+5

.SaveTanks
   rts

DisplayMissed SUBROUTINE
   lda   #$40
   sta   VBWAIT
   lda   #$20
   sta   $2006
   lda   #$4E
   sta   $2006
   ldx   #$00
.DrawMiss1 lda  .MissText,X
   beq   .NoDrawMiss1
   sta   $2007
   inx
   jmp   .DrawMiss1
.NoDrawMiss1

   lda   #$24
   sta   $2006
   lda   #$4E
   sta   $2006
   ldx   #$00
.DrawMiss2 lda  .MissText,X
   beq   .NoDrawMiss2
   sta   $2007
   inx
   jmp   .DrawMiss2
.NoDrawMiss2

   lda   P1SCORE
   ora   #$10
   sta   P1SCRSCORE
   lda   P2SCORE
   ora   #$10
   sta   P2SCRSCORE
   rts

.MissText   dc.b "MISS!"
   dc.b  #$00

DisplayHit SUBROUTINE
   lda   #$60
   sta   VBWAIT
   lda   #$20
   sta   $2006
   lda   #$4E
   sta   $2006
   ldx   #$00
.DrawHit1 lda  .HitText,X
   beq   .NoDrawHit1
   sta   $2007
   inx
   jmp   .DrawHit1
.NoDrawHit1

   lda   #$24
   sta   $2006
   lda   #$4E
   sta   $2006
   ldx   #$00
.DrawHit2 lda  .HitText,X
   beq   .NoDrawHit2
   sta   $2007
   inx
   jmp   .DrawHit2
.NoDrawHit2

   lda   P1SCORE
   ora   #$10
   sta   P1SCRSCORE
   lda   P2SCORE
   ora   #$10
   sta   P2SCRSCORE
   rts

.HitText    dc.b "HIT!"
   dc.b #$00

ClearMessage SUBROUTINE
   lda   #$20
   sta   $2006
   lda   #$4E
   sta   $2006
   lda   #$00
   ldy   #$05
.ClearMsg1
   sta   $2007
   dey
   bne   .ClearMsg1

   lda   #$24
   sta   $2006
   lda   #$4E
   sta   $2006
   lda   #$00
   ldy   #$05
.ClearMsg2
   sta   $2007
   dey
   bne   .ClearMsg2

   rts

InitBall SUBROUTINE
   ldx   PLAYER
   lda   P1POSY,X
   clc
   sbc   #$04           ;Make ball appear higher than tank.
   eor   #$FF
   sta   BALLPLOY
   lda   #$00
   sta   BALLPHIY
   asl   BALLPLOY
   rol   BALLPHIY
   asl   BALLPLOY
   rol   BALLPHIY
   asl   BALLPLOY
   rol   BALLPHIY
   asl   BALLPLOY
   rol   BALLPHIY
   asl   BALLPLOY
   rol   BALLPHIY
   asl   BALLPLOY
   rol   BALLPHIY

   ldx   PLAYER
   lda   P1POSX,X
   sta   BALLPLOX
   lda   #$00
   sta   BALLPHIX
   asl   BALLPLOX
   rol   BALLPHIX
   asl   BALLPLOX
   rol   BALLPHIX
   asl   BALLPLOX
   rol   BALLPHIX
   asl   BALLPLOX
   rol   BALLPHIX
   asl   BALLPLOX
   rol   BALLPHIX
   asl   BALLPLOX
   rol   BALLPHIX

   ldx   PLAYER
   lda   P1VINITHIY,X
   sta   BALLVHIY
   lda   P1VINITLOY,X
   sta   BALLVLOY

   lda   P1VINITHIX,X
   sta   BALLVHIX
   lda   P1VINITLOX,X
   sta   BALLVLOX

   lda   PLAYER
   beq   .NotPlayer2InitBall
   clc
   lda   BALLPHIX
   adc   #$40
   sta   BALLPHIX

.NotPlayer2InitBall
   rts

Gravity SUBROUTINE
   lda   BALLVLOY
   sec
   sbc   BALLACCY
   sta   BALLVLOY
   bcs   .NoOverflowVY
   dec   BALLVHIY
.NoOverflowVY

   lda   BALLPLOY
   clc
   adc   BALLVLOY
   sta   BALLPLOY
   bcc   .NoOverflowPLOY
   inc   BALLPHIY
.NoOverflowPLOY
   lda   BALLPHIY
   clc
   adc   BALLVHIY
   sta   BALLPHIY

   lda   BALLPHIY
   pha
   lda   BALLPLOY
   pha
   lsr   BALLPHIY
   ror   BALLPLOY
   lsr   BALLPHIY
   ror   BALLPLOY
   lsr   BALLPHIY
   ror   BALLPLOY
   lsr   BALLPHIY
   ror   BALLPLOY
   lsr   BALLPHIY
   ror   BALLPLOY
   lsr   BALLPHIY
   ror   BALLPLOY
   lda   BALLPLOY
   eor   #$FF
   sta   BALLSCRPY

   pla
   sta   BALLPLOY
   pla
   sta   BALLPHIY

;---------------------- X-POS -------------
   lda   BALLVLOX
   clc
   adc   BALLACCX
   sta   BALLVLOX
   bcc   .NoOverflowVX
   inc   BALLVHIX
.NoOverflowVX

   lda   BALLPLOX
   clc
   adc   BALLVLOX
   sta   BALLPLOX
   bcc   .NoOverflowP1LOX
   inc   BALLPHIX
.NoOverflowP1LOX
   lda   BALLVHIX
   clc
   adc   BALLPHIX
   sta   BALLPHIX

.ShiftPX
   lda   BALLPHIX
   pha
   lda   BALLPLOX
   pha
   lsr   BALLPHIX
   ror   BALLPLOX
   lsr   BALLPHIX
   ror   BALLPLOX
   lsr   BALLPHIX
   ror   BALLPLOX
   lsr   BALLPHIX
   ror   BALLPLOX
   lsr   BALLPHIX
   ror   BALLPLOX
   lsr   BALLPHIX
   ror   BALLPLOX
   lda   BALLPLOX
   sta   BALLSCRPX

   pla
   sta   BALLPLOX
   pla
   sta   BALLPHIX

;------------ TESTING FOR OFF-SCREEN ------------------------------
   lda   BALLPHIY
   and   #%11000000
   beq   .StillVisible
   lda   #$00
   jmp   .GravEnd
.StillVisible
   lda   #$01
.GravEnd
   sta   BALLVISIBLE

;------------ TEST FOR MISS -------------
   lda   FIRED
   bne   .YesHitDetect
   jmp   .NoHitDetect
.YesHitDetect
   lda   BALLVISIBLE
   beq   .NotYMissed
   lda   #$DF
   cmp   BALLSCRPY
   bcs   .NotYMissed

   lda   #$01
   sta   MISSED
   lda   #$00
   sta   FIRED
   lda   #$00
   sta   BALLVISIBLE

.NotYMissed
   lda   BALLPHIX
   and   #$80
   beq   .NotXMissed
   lda   #$01
   sta   MISSED
   lda   #$00
   sta   FIRED
   lda   #$00
   sta   BALLVISIBLE
;   lda   PLAYER
.NotXMissed

;---------- TEST FOR GROUND HIT ------------------

   lda   FIRED
   bne   .YesGroundDetect
   jmp   .NoHitDetect
.YesGroundDetect
   lda   BALLVISIBLE
   beq   .NotGroundHit

   lda   BALLSCRPX      ;X-Position
   lsr
   lsr
   lsr
   tay
   lda   BALLPHIX
   lsr
   and   #$20
   sta   $0100          ;Is it on Screen 1 or 2?
   tya
   clc
   adc   $0100
   tay
   lda   BALLSCRPY      ;Y-Value
   lsr
   lsr
   lsr
   cmp   (TERRAINPTR),Y
   bmi   .NotGroundHit

   lda   #$01
   sta   MISSED
   lda   #$00
   sta   FIRED
   lda   #$00
   sta   BALLVISIBLE

.NotGroundHit

;----- TEST FOR HIT ------------------------------
   lda   PLAYER               ;Is Player 1 Firing?
   bne   .Player2HitTest
   lda   BALLVISIBLE          ;Is the ball on(the proper)screen?
   beq   .NoP1HitTest
   lda   BALLPHIX             ;Is the ball in the 2nd Player's Screen?
   and   #%01000000           ;(Pos=40-7F)
   beq   .NoP1HitTest
   lda   BALLSCRPY
   lsr
   lsr
   lsr                        ;Check if at nearest 8 pixels
   sta   $100                ;JUST TEMPORARY!
   lda   P2POSY
   lsr
   lsr
   lsr
   cmp   $100                 ;Are in near position?
   bne   .NoP1HitTest
   lda   BALLSCRPX
   lsr
   lsr
   lsr
   lsr                       ;Check if at nearest 16 pixels
   sta   $100                ;JUST TEMPORARY!
   lda   P2POSX
   lsr
   lsr
   lsr
   lsr
   cmp   $100
   bne   .NoHitTestYet

.P1IsHit
   lda   #$01
   sta   HIT
   lda   #$00
   sta   FIRED
   lda   #$00
   sta   BALLVISIBLE
.NoP1HitTest   jmp   .NoHitTestYet

.Player2HitTest
   lda   BALLVISIBLE          ;Is the ball on(the proper)screen?
   beq   .NoHitTestYet
   lda   BALLPHIX             ;Is the ball in the 1st Player's Screen?
   and   #%01000000           ;(Pos=40-7F)
   bne   .NoHitTestYet
   lda   BALLSCRPY
   lsr
   lsr
   lsr                        ;Check if at nearest 8 pixels
   sta   $100                ;JUST TEMPORARY!
   lda   P1POSY
   lsr
   lsr
   lsr
   cmp   $100                 ;Are in near position?
   bne   .NoHitTestYet
   lda   BALLSCRPX
   lsr
   lsr
   lsr
   lsr                       ;Check if at nearest 16 pixels
   sta   $100                ;JUST TEMPORARY!
   lda   P1POSX
   lsr
   lsr
   lsr
   lsr
   cmp   $100
   bne   .NoHitTestYet

.P2IsHit
   lda   #$01
   sta   HIT
   lda   #$00
   sta   FIRED
   lda   #$00
   sta   BALLVISIBLE

.NoHitTestYet
;------------------------------------
.NoHitDetect
   rts




NMI_Routine SUBROUTINE
   php
   pha
   txa
   pha
   tya
   pha


   lda   VBWAIT
   beq   .NoWaiting
   dec   VBWAIT
   bne   .NotFinishedMsg
   eor   PLAYER               ;Switch between Player1 and Player2
   sta   PLAYER
   jsr   InitBall
   jsr   ClearMessage
   lda   #$01
   sta   READY
   jmp   .NoWaiting
.NotFinishedMsg
   jmp   .VBEnd
.NoWaiting

;---------- READ JOYPAD -----------------------

   ldx   #$01
   stx   $4016
   stx   $4017
   dex
   stx   $4016
   stx   $4017
   ldy   #$08     ;Read 8 bits from $4016
   lda   #$00
   sta   CONTROLLER1
   ldx   PLAYER
.ReadCont1
   lda   $4016            ;,X for Controller 2.
   ror
   lda   CONTROLLER1
   rol
   sta   CONTROLLER1
   dey
   bne   .ReadCont1
   sta   CONTROLLER1
;---------------------------------------------

   lda   MISSED
   bne   .Missed
   lda   HIT
   bne   .Hit
   lda   FIRED
   beq   .NotFired
   jsr   Gravity
   jmp   .UpdateSprites
.Hit
   lda   #$00
   sta   HIT
   ldx   PLAYER
   inc   P1SCORE,X
   jsr   DisplayHit
   jmp   .UpdateSprites
.Missed
   jsr   DisplayMissed
   lda   #$00
   sta   MISSED
;   jsr   InitBall
.NotFired
.UpdateSprites
   lda   BALLVISIBLE
   asl
   sta   BALLCHR

   jsr   ShowHideTanks

   lda   #$07
   sta   $4014             ;Copy $700 to Spr-RAM

;--- SET SCROLLING ----------
   lda   #$40
   and   BALLPHIX
   beq   .ScreenA
   lda   #%10001001
   jmp   .SaveScrolling
.ScreenA lda   #%10001000
.SaveScrolling
   sta   $2000
   lda   #$00
   sta   $2005
   sta   $2005

.VBEnd

   pla
   tay
   pla
   tax
   pla
   plp
   rti

IRQ_Routine       ;Dummy label
   rti

;That's all the code. Now we just need to set the vector table approriately.

   ORG   $FFFA,0
   dc.w  NMI_Routine
   dc.w  Reset_Routine
   dc.w  IRQ_Routine    ;Not used, just points to RTI


;The end.
